####################
# PLF build
%define build_plf 0
####################

%define disable_inappropriate 1
# Allow --with[out] <feature> at rpm command line build
%{?_with_plf: %{expand: %%global build_plf 1}}
%{?_without_plf: %{expand: %%global build_plf 0}}
%{?_with_inappropriate: %{expand: %%global disable_inappropriate 0}}
%{?_without_inappropriate: %{expand: %%global disable_inappropriate 1}}

%if %{build_plf}
%define distsuffix plf
# make EVR of plf build higher than regular to allow update, needed with rpm5 mkrel
%define extrarelsuffix plf
%endif

Summary:	A set of X Window System screensavers
Name:		xscreensaver
Version:	5.26
Release:	1%{?extrarelsuffix}
License:	BSD
Group:		Graphical desktop/Other
URL:		http://www.jwz.org/xscreensaver/
Source0:	http://www.jwz.org/xscreensaver/%{name}-%{version}.tar.gz
Source1:	xscreensaver-capplet.png
Source2:	dmctl
Source3:        update-xscreensaver-hacks
Patch0:         xscreensaver-5.05-mdv-alt-drop_setgid.patch
# Don't check login manager in PATH because we use custom wrapper
Patch1:         xscreensaver-5.15-lmcheck.patch
# Only GDadou should be enabled
Patch9:         xscreensaver-5.15-defaultconfig.patch
# (fc) 4.00-4mdk allow root to start xscreensaver
Patch10:        xscreensaver-4.23-root.patch
# (fc) 4.05-3mdk disable openGL hacks by default
Patch11:        xscreensaver-5.09-noGL.patch

Patch12:	xscreensaver-5.26-autoreconf.patch

# fedora patches
# bug 129335
# sanitize the names of modes in barcode
Patch1001:          xscreensaver-5.26-sanitize-hacks.patch
## Patches already sent to the upsteam
## Patches which must be discussed with upstream
#
# Change webcollage not to access to net
# Also see bug 472061
Patch1021:         xscreensaver-5.26-webcollage-default-nonet.patch
#
# Update Japanese po file
Patch1032:         xscreensaver-5.13-dpmsQuickoff-japo.patch
# driver/test-passwd tty segfaults
Patch1051:         xscreensaver-5.12-test-passwd-segv-tty.patch
# patch to compile driver/test-xdpms
Patch1052:         xscreensaver-5.12-tests-miscfix.patch

Patch1100:      xscreensaver-5.26-0000-make-sync_server_dpms_settings-consistent-for-dpms_q.patch
# Kill memleak on goop
Patch1101:      xscreensaver-5.26-0001-Kill-memleak-on-goop-on-resize.patch
# Shut down cppcheck error / warning messages
Patch1102:      xscreensaver-5.26-0002-asm6502.c-shut-down-error-message-from-cppcheck.patch
Patch1103:      xscreensaver-5.26-0003-demo-Gtk.c-shut-down-error-message-from-cppcheck.patch
Patch1104:      xscreensaver-5.26-0004-asm6502.c-shut-down-error-message-from-cppcheck.patch
Patch1105:      xscreensaver-5.26-0005-splash.c-shut-down-warning-message-from-cppcheck.patch

Requires:	xscreensaver-common = %{version}-%{release}
Requires:	fortune-mod
Requires:	mandriva-theme-screensaver
Requires:	xdg-utils
BuildRequires:	makedepend
BuildRequires:	bc
BuildRequires:	fortune-mod
BuildRequires:	jpeg-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(glut)
BuildRequires:	pkgconfig(gdk-pixbuf-xlib-2.0)
BuildRequires:	pkgconfig(libglade-2.0)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xmu)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xt)
BuildRequires:	pkgconfig(xxf86misc)
BuildRequires:	pkgconfig(xxf86vm)
BuildRequires:	gle-devel
BuildRequires:	imagemagick

%description
The xscreensaver package contains a variety of screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure.

Install the xscreensaver package if you need screensavers for use with
the X Window System.

%if %{build_plf}
This package is in restricted as it contains copyrighted images.
%endif

%package base
Summary:	A set of screensavers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Conflicts:	xscreensaver < 5.00-2
Requires:	words

%description base
Various screensavers used by Xscreensaver.

%package common
Summary:	Utilities used by xscreensaver screensavers
Group:		Graphical desktop/Other
Conflicts:	xscreensaver < 5.00-2
Provides:	xscreensaver-utils
Requires:	chbg

%description common
Utilities used by xscreensaver screensavers.

%package gl
Summary:	A set of GL screensavers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Requires(post):	xscreensaver-common = %{version}-%{release}
Requires(postun):	xscreensaver-common = %{version}-%{release}

%description gl
The xscreensaver-gl package contains even more screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screensavers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screensavers for
use with the X Window System and you have OpenGL or Mesa installed.

%if %{build_plf}
%package matrix
Summary:	The Matrix screensavers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description matrix
The xscreensaver-matrix package contains two screensavers for
xscreensaver based on the movie The Matrix. It is in restricted because
there might by copyright problems with the artwork used in this
screensavers.
%endif

%package extrusion
Summary:	OpenGL screensaver
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description extrusion
The xscreensaver-extrusion package contains the extrusion
screensaversfor your mind-numbing, ambition-eroding, time-wasting,
hypnotized viewing pleasure. This screensaver requires OpenGL or Mesa
support.

This screensaver is in a separate package, because it is the only
application for the ROSA Linux distribution which requires the GLE
extrusion library.

%prep
%setup -q
%patch1 -p1 -b .login-manager
# WARNING this patch must ALWAYS be applied, if it fails, REGENERATE it !!!
%patch9 -p1 -b .defaultconfig
ln -srf po/Makefile.in{,.in}
%patch10 -p1 -b .root
%patch11 -p1 -b .noGL
%if %{disable_inappropriate}
%patch1001 -p1 -b .inappropriate
%endif

%patch12 -p1 -b .autoconf

%patch1021 -p1
%patch1032 -p1
%patch1051 -p1
%patch1052 -p1
%patch1100 -p1
%patch1101 -p1
%patch1102 -p1
%patch1103 -p1
%patch1104 -p1
%patch1105 -p1


# Needed by patches 1 and 11
autoconf

%build
%configure2_5x \
    --enable-locking \
    --enable-root-passwd \
    --with-browser=xdg-open \
    --with-dpms-ext \
    --with-xinerama-ext \
    --with-xf86vmode-ext \
    --with-xf86gamma-ext \
    --with-randr-ext \
    --with-proc-interrupts \
    --with-login-manager=dmctl \
    --without-shadow \
    --with-pixbuf \
    --with-xpm \
    --with-jpeg \
    --with-xshm-ext \
    --with-xdbe-ext \
    --without-readdisplay \
    --without-setuid-hacks \
    --with-gtk \
    --without-motif \
    --with-pam \
    --enable-pam-check-account-type \
    --with-gl \
    --with-image-directory=%{_datadir}/mdk/screensaver \
    --with-x-app-defaults=%{_datadir}/X11/app-defaults \
    --without-kerberos \
    --with-text-file=%{_sysconfdir}/release \
    --with-gle

make distdepend
make depend DEPEND="makedepend -I$(gcc -print-search-dirs|sed -e 's#^install: \(.*\).*#\1#g'|head -n1)/include"
#make depend
sed 's/\@ALL_LINGUAS\@/"ca da de es et fi fr hu it ja ko nb nl pl pt pt_BR ru sk sv vi wa zh_CN zh_TW"/' -i po/Makefile 
%make

%install
rm -rf %{buildroot} gl-extras.files base.files %{name}.lang
# mkdir -p %{buildroot}%{_sysconfdir}/X11/app-defaults/
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man6
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
mkdir -p %{buildroot}%{_libexecdir}/xscreensaver

make install_prefix=%{buildroot} bindir=%{_bindir} \
 KDEDIR=%{_prefix} GNOME_BINDIR=%{_bindir}  GNOME_DATADIR=%{_datadir} \
 mandir=%{_mandir} AD_DIR=%{_datadir}/X11/app-defaults/ \
 gnulocaledir=%{_datadir}/locale install
%makeinstall -C po

install -p -m755 %{SOURCE3} -D %{buildroot}%{_sbindir}/update-xscreensaver-hacks

# Custom wrapper for gdmflexiserver and kdmctl
install -m 755 %{SOURCE2} %{buildroot}%{_bindir}/dmctl

cat<<EOF >README.GL
The xscreensaver-gl package contains even more screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screensavers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screensavers for
use with the X Window System and you have OpenGL or Mesa installed.
EOF

#icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_iconsdir}/hicolor/{16x16,32x32,48x48}/apps
cp %{SOURCE1}  %{buildroot}%{_datadir}/pixmaps
convert -scale 16x16 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png
convert -scale 32x32 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
ln -s %{_datadir}/pixmaps/xscreensaver-capplet.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png

#remove unpackaged files
rm -f %{buildroot}%{_datadir}/xscreensaver/config/xjack.xml
rm -f %{buildroot}%{_mandir}/man6/xjack.6
rm -f  %{buildroot}%{_libexecdir}/xscreensaver/xjack

%if ! %{build_plf}
rm -rf %{buildroot}%{_libexecdir}/xscreensaver/*matrix
rm -rf %{buildroot}%{_mandir}/man6/*matrix*
rm -rf %{buildroot}%{_datadir}/xscreensaver/config/*matrix*
%endif

%find_lang %{name}

# This function prints a list of things that get installed.
# It does this by parsing the output of a dummy run of "make install".
#
list_files() {
  make -s install_prefix=%{buildroot} mandir=%{_mandir}/ \
  bindir=%{_bindir} INSTALL=true "$@"	\
   | sed -n -e 's@.* \(/[^ ]*\)$@\1@p'				\
   | sed    -e "s@^%{buildroot}@@"				\
	    -e "s@/[a-z][a-z]*/\.\./@/@"			\
   | sed    -e 's@\(.*/man/.*\)@\1\*@'				\
   | sed    -e 's@\(.*/app-defaults/\)@%config \1@'		\
	    -e 's@\(.*/pam\.d/\)@%config(missingok) \1@'	\
   | sort
}

# Generate three lists of files for the three packages.
#
dd=%{_builddir}/%{name}-%{version}
( cd hacks/glx ; list_files install > $dd/gl-extras.files)
( cd hacks     ; list_files install > $dd/base.files)

#gw remove the files we don't package:
perl -pi -e "s/.*(gdadou|xjack|matrix|extrusion).*//" gl-extras.files base.files

%find_lang %{name}

%post gl
sed -i -e 's/\A-\s+GL:/ GL:/' %{_sysconfdir}/X11/app-defaults/XScreenSaver

%postun gl
sed -i -e '/\A\s*GL:/ and print "- $_" or print "$_"' %{_sysconfdir}/X11/app-defaults/XScreenSaver

%files -f %{name}.lang
%config(noreplace) %{_sysconfdir}/pam.d/xscreensaver
%doc README
%{_mandir}/man1/xscreensaver-command.1*
%{_mandir}/man1/xscreensaver-demo.1*
%{_mandir}/man1/xscreensaver.1*
%attr(755,root,chkpwd) %{_bindir}/xscreensaver
%{_bindir}/xscreensaver-command
%{_bindir}/xscreensaver-demo
%{_bindir}/dmctl
%dir %{_datadir}/xscreensaver
%{_datadir}/xscreensaver/glade
%{_datadir}/applications/xscreensaver-properties.desktop
%{_datadir}/pixmaps/*
%{_datadir}/xscreensaver/config/gdadou.xml
%{_iconsdir}/hicolor/*/apps/*.png

%files common
# %config(noreplace) %{_sysconfdir}/X11/app-defaults/*
%{_datadir}/X11/app-defaults/*
%dir %{_libexecdir}/%{name}
%{_bindir}/xscreensaver-getimage
%{_bindir}/xscreensaver-getimage-file
%{_bindir}/xscreensaver-getimage-video
%{_bindir}/xscreensaver-text
%{_mandir}/man1/xscreensaver-getimage*
%{_mandir}/man1/xscreensaver-text.1*
%dir %{_datadir}/%{name}/config
%{_datadir}/%{name}/config/README

%files base -f base.files
%{_sbindir}/update-xscreensaver-hacks

%files gl -f gl-extras.files
%doc README.GL

%files extrusion
%doc README.GL
%{_datadir}/xscreensaver/config/extrusion.xml
%{_mandir}/man6/extrusion.6*
%{_libexecdir}/xscreensaver/extrusion

%if %{build_plf}
%files matrix
%doc README.GL
%{_mandir}/man6/xmatrix.6*
%{_mandir}/man6/glmatrix.6*
%{_datadir}/xscreensaver/config/glmatrix.xml
%{_datadir}/xscreensaver/config/xmatrix.xml
%{_libexecdir}/xscreensaver/xmatrix
%{_libexecdir}/xscreensaver/glmatrix
%endif




%changelog
* Thu Aug 28 2014 Denis Silakov <denis.silakov@rosalab.ru> 5.26-1
+ Revision: 74ddfa9
- Fix files


